Index: squid/src/store_dir.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/store_dir.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.3
diff -u -r1.1.1.2 -r1.1.1.3
--- squid/src/store_dir.c	26 Jan 2000 03:23:10 -0000	1.1.1.2
+++ squid/src/store_dir.c	26 Jan 2000 03:25:01 -0000	1.1.1.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: store_dir.c,v 1.1.1.2 2000/01/26 03:23:10 hno Exp $
+ * $Id: store_dir.c,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
  *
  * DEBUG: section 47    Store Directory Routines
  * AUTHOR: Duane Wessels
@@ -34,196 +34,45 @@
  */
 
 #include "squid.h"
-#if HAVE_STATVFS
-#if HAVE_SYS_STATVFS_H
-#include <sys/statvfs.h>
-#endif
-#endif
-
-#define SWAP_DIR_SHIFT 24
-#define SWAP_FILE_MASK 0x00FFFFFF
-#define DefaultLevelOneDirs     16
-#define DefaultLevelTwoDirs     256
-
-static char *storeSwapSubDir(int dirn, int subdirn);
-static int storeDirSelectSwapDir(void);
-static int storeVerifyDirectory(const char *path);
-static int storeCreateDirectory(const char *path, int);
-static void storeCreateSwapSubDirs(int j);
-
-/* return full name to swapfile */
-char *
-storeSwapFullPath(int fn, char *fullpath)
-{
-    LOCAL_ARRAY(char, fullfilename, SQUID_MAXPATHLEN);
-    int dirn = (fn >> SWAP_DIR_SHIFT) % Config.cacheSwap.n_configured;
-    int filn = fn & SWAP_FILE_MASK;
-    int L1 = Config.cacheSwap.swapDirs[dirn].l1;
-    int L2 = Config.cacheSwap.swapDirs[dirn].l2;
-    if (!fullpath)
-	fullpath = fullfilename;
-    fullpath[0] = '\0';
-    snprintf(fullpath, SQUID_MAXPATHLEN, "%s/%02X/%02X/%08X",
-	Config.cacheSwap.swapDirs[dirn].path,
-	((filn / L2) / L2) % L1,
-	(filn / L2) % L2,
-	filn);
-    return fullpath;
-}
-
-static char *
-storeSwapSubDir(int dirn, int subdirn)
-{
-    LOCAL_ARRAY(char, fullfilename, SQUID_MAXPATHLEN);
-    SwapDir *SD;
-    assert(0 <= dirn && dirn < Config.cacheSwap.n_configured);
-    SD = &Config.cacheSwap.swapDirs[dirn];
-    assert(0 <= subdirn && subdirn < SD->l1);
-    snprintf(fullfilename, SQUID_MAXPATHLEN, "%s/%02X",
-	Config.cacheSwap.swapDirs[dirn].path,
-	subdirn);
-    return fullfilename;
-}
-
-char *
-storeSwapSubSubDir(int fn, char *fullpath)
-{
-    LOCAL_ARRAY(char, fullfilename, SQUID_MAXPATHLEN);
-    int dirn = (fn >> SWAP_DIR_SHIFT) % Config.cacheSwap.n_configured;
-    int filn = fn & SWAP_FILE_MASK;
-    int L1 = Config.cacheSwap.swapDirs[dirn].l1;
-    int L2 = Config.cacheSwap.swapDirs[dirn].l2;
-    if (!fullpath)
-	fullpath = fullfilename;
-    fullpath[0] = '\0';
-    snprintf(fullpath, SQUID_MAXPATHLEN, "%s/%02X/%02X",
-	Config.cacheSwap.swapDirs[dirn].path,
-	((filn / L2) / L2) % L1,
-	(filn / L2) % L2);
-    return fullpath;
-}
-
-/*
- * Does swapfile number 'fn' belong in cachedir #F0,
- * level1 dir #F1, level2 dir #F2?
- *
- * This is called by storeDirClean(), but placed here because
- * the algorithm needs to match storeSwapSubSubDir().
- *
- * Don't check that (fn >> SWAP_DIR_SHIFT) == F0 because
- * 'fn' may not have the directory bits set.
- */
-int
-storeFilenoBelongsHere(int fn, int F0, int F1, int F2)
-{
-    int D1, D2;
-    int L1, L2;
-    int filn = fn & SWAP_FILE_MASK;
-    assert(F0 < Config.cacheSwap.n_configured);
-    L1 = Config.cacheSwap.swapDirs[F0].l1;
-    L2 = Config.cacheSwap.swapDirs[F0].l2;
-    D1 = ((filn / L2) / L2) % L1;
-    if (F1 != D1)
-	return 0;
-    D2 = (filn / L2) % L2;
-    if (F2 != D2)
-	return 0;
-    return 1;
-}
-
-static int
-storeCreateDirectory(const char *path, int should_exist)
-{
-    int created = 0;
-    struct stat st;
-    getCurrentTime();
-    if (0 == stat(path, &st)) {
-	if (S_ISDIR(st.st_mode)) {
-	    debug(20, should_exist ? 3 : 1) ("%s exists\n", path);
-	} else {
-	    fatalf("Swap directory %s is not a directory.", path);
-	}
-    } else if (0 == mkdir(path, 0755)) {
-	debug(20, should_exist ? 1 : 3) ("%s created\n", path);
-	created = 1;
-    } else {
-	fatalf("Failed to make swap directory %s: %s",
-	    path, xstrerror());
-    }
-    return created;
-}
 
-static int
-storeVerifyDirectory(const char *path)
+const char *SwapDirType[] =
 {
-    struct stat sb;
-    if (stat(path, &sb) < 0) {
-	debug(20, 0) ("%s: %s\n", path, xstrerror());
-	return -1;
-    }
-    if (S_ISDIR(sb.st_mode) == 0) {
-	debug(20, 0) ("%s is not a directory\n", path);
-	return -1;
-    }
-    return 0;
-}
+    "ufs",
+    "!ERROR!"
+};
 
-/*
- * This function is called by storeInit().  If this returns < 0,
- * then Squid exits, complains about swap directories not
- * existing, and instructs the admin to run 'squid -z'
- */
-int
-storeVerifyCacheDirs(void)
+void
+storeDirInit(void)
 {
     int i;
-    int j;
-    const char *path;
+    SwapDir *sd;
     for (i = 0; i < Config.cacheSwap.n_configured; i++) {
-	path = Config.cacheSwap.swapDirs[i].path;
-	if (storeVerifyDirectory(path) < 0)
-	    return -1;
-	for (j = 0; j < Config.cacheSwap.swapDirs[i].l1; j++) {
-	    path = storeSwapSubDir(i, j);
-	    if (storeVerifyDirectory(path) < 0)
-		return -1;
-	}
+	sd = &Config.cacheSwap.swapDirs[i];
+	sd->init(sd);
     }
-    return 0;
 }
 
 void
 storeCreateSwapDirectories(void)
 {
     int i;
-    const char *path = NULL;
+    SwapDir *sd;
+    pid_t pid;
+    int status;
     for (i = 0; i < Config.cacheSwap.n_configured; i++) {
-	path = Config.cacheSwap.swapDirs[i].path;
-	debug(47, 3) ("Creating swap space in %s\n", path);
-	storeCreateDirectory(path, 0);
-	storeCreateSwapSubDirs(i);
-    }
-}
-
-static void
-storeCreateSwapSubDirs(int j)
-{
-    int i, k;
-    int should_exist;
-    SwapDir *SD = &Config.cacheSwap.swapDirs[j];
-    LOCAL_ARRAY(char, name, MAXPATHLEN);
-    for (i = 0; i < SD->l1; i++) {
-	snprintf(name, MAXPATHLEN, "%s/%02X", SD->path, i);
-	if (storeCreateDirectory(name, 0))
-	    should_exist = 0;
-	else
-	    should_exist = 1;
-	debug(47, 1) ("Making directories in %s\n", name);
-	for (k = 0; k < SD->l2; k++) {
-	    snprintf(name, MAXPATHLEN, "%s/%02X/%02X", SD->path, i, k);
-	    storeCreateDirectory(name, should_exist);
-	}
-    }
+	if (fork())
+	    continue;
+	sd = &Config.cacheSwap.swapDirs[i];
+	sd->newfs(sd);
+	exit(0);
+    }
+    do {
+#ifdef _SQUID_NEXT_
+	pid = wait3(&status, WNOHANG, NULL);
+#else
+	pid = waitpid(-1, &status, 0);
+#endif
+    } while (pid > 0 || (pid < 0 && errno == EINTR));
 }
 
 /*
@@ -318,7 +167,7 @@
 }
 
 int
-storeDirValidFileno(int fn)
+storeDirValidFileno(int fn, int flag)
 {
     int dirn = fn >> SWAP_DIR_SHIFT;
     int filn = fn & SWAP_FILE_MASK;
@@ -328,8 +177,13 @@
 	return 0;
     if (filn < 0)
 	return 0;
-    if (filn > Config.cacheSwap.swapDirs[dirn].map->max_n_files)
-	return 0;
+    /*
+     * If flag is set it means out-of-range file number should
+     * be considered invalid.
+     */
+    if (flag)
+	if (filn > Config.cacheSwap.swapDirs[dirn].map->max_n_files)
+	    return 0;
     return 1;
 }
 
@@ -398,9 +252,8 @@
 void
 storeDirSwapLog(const StoreEntry * e, int op)
 {
-    storeSwapLogData *s;
-    int dirn;
-    dirn = e->swap_file_number >> SWAP_DIR_SHIFT;
+    int dirn = e->swap_file_number >> SWAP_DIR_SHIFT;
+    SwapDir *sd;
     assert(dirn < Config.cacheSwap.n_configured);
     assert(!EBIT_TEST(e->flags, KEY_PRIVATE));
     assert(e->swap_file_number >= 0);
@@ -414,156 +267,8 @@
 	swap_log_op_str[op],
 	storeKeyText(e->key),
 	e->swap_file_number);
-    s = xcalloc(1, sizeof(storeSwapLogData));
-    s->op = (char) op;
-    s->swap_file_number = e->swap_file_number;
-    s->timestamp = e->timestamp;
-    s->lastref = e->lastref;
-    s->expires = e->expires;
-    s->lastmod = e->lastmod;
-    s->swap_file_sz = e->swap_file_sz;
-    s->refcount = e->refcount;
-    s->flags = e->flags;
-    xmemcpy(s->key, e->key, MD5_DIGEST_CHARS);
-    file_write(Config.cacheSwap.swapDirs[dirn].swaplog_fd,
-	-1,
-	s,
-	sizeof(storeSwapLogData),
-	NULL,
-	NULL,
-	xfree);
-}
-
-char *
-storeDirSwapLogFile(int dirn, const char *ext)
-{
-    LOCAL_ARRAY(char, path, SQUID_MAXPATHLEN);
-    LOCAL_ARRAY(char, digit, 32);
-    if (Config.Log.swap) {
-	xstrncpy(path, Config.Log.swap, SQUID_MAXPATHLEN - 64);
-	strcat(path, ".");
-	snprintf(digit, 32, "%02d", dirn);
-	strncat(path, digit, 3);
-    } else {
-	xstrncpy(path, storeSwapDir(dirn), SQUID_MAXPATHLEN - 64);
-	strcat(path, "/swap.state");
-    }
-    if (ext)
-	strncat(path, ext, 16);
-    return path;
-}
-
-void
-storeDirOpenSwapLogs(void)
-{
-    int i;
-    char *path;
-    int fd;
-    SwapDir *SD;
-    for (i = 0; i < Config.cacheSwap.n_configured; i++) {
-	SD = &Config.cacheSwap.swapDirs[i];
-	path = storeDirSwapLogFile(i, NULL);
-	fd = file_open(path, O_WRONLY | O_CREAT, NULL, NULL, NULL);
-	if (fd < 0) {
-	    debug(50, 1) ("%s: %s\n", path, xstrerror());
-	    fatal("storeDirOpenSwapLogs: Failed to open swap log.");
-	}
-	debug(47, 3) ("Cache Dir #%d log opened on FD %d\n", i, fd);
-	SD->swaplog_fd = fd;
-    }
-}
-
-void
-storeDirCloseSwapLogs(void)
-{
-    int i;
-    SwapDir *SD;
-    for (i = 0; i < Config.cacheSwap.n_configured; i++) {
-	SD = &Config.cacheSwap.swapDirs[i];
-	if (SD->swaplog_fd < 0)	/* not open */
-	    continue;
-	file_close(SD->swaplog_fd);
-	debug(47, 3) ("Cache Dir #%d log closed on FD %d\n", i, SD->swaplog_fd);
-	SD->swaplog_fd = -1;
-    }
-}
-
-FILE *
-storeDirOpenTmpSwapLog(int dirn, int *clean_flag, int *zero_flag)
-{
-    char *swaplog_path = xstrdup(storeDirSwapLogFile(dirn, NULL));
-    char *clean_path = xstrdup(storeDirSwapLogFile(dirn, ".last-clean"));
-    char *new_path = xstrdup(storeDirSwapLogFile(dirn, ".new"));
-    struct stat log_sb;
-    struct stat clean_sb;
-    SwapDir *SD = &Config.cacheSwap.swapDirs[dirn];
-    FILE *fp;
-    int fd;
-    if (stat(swaplog_path, &log_sb) < 0) {
-	debug(47, 1) ("Cache Dir #%d: No log file\n", dirn);
-	safe_free(swaplog_path);
-	safe_free(clean_path);
-	safe_free(new_path);
-	return NULL;
-    }
-    *zero_flag = log_sb.st_size == 0 ? 1 : 0;
-    /* close the existing write-only FD */
-    if (SD->swaplog_fd >= 0)
-	file_close(SD->swaplog_fd);
-    /* open a write-only FD for the new log */
-    fd = file_open(new_path, O_WRONLY | O_CREAT | O_TRUNC, NULL, NULL, NULL);
-    if (fd < 0) {
-	debug(50, 1) ("%s: %s\n", new_path, xstrerror());
-	fatal("storeDirOpenTmpSwapLog: Failed to open swap log.");
-    }
-    SD->swaplog_fd = fd;
-    /* open a read-only stream of the old log */
-    fp = fopen(swaplog_path, "r");
-    if (fp == NULL) {
-	debug(50, 0) ("%s: %s\n", swaplog_path, xstrerror());
-	fatal("Failed to open swap log for reading");
-    }
-    memset(&clean_sb, '\0', sizeof(struct stat));
-    if (stat(clean_path, &clean_sb) < 0)
-	*clean_flag = 0;
-    else if (clean_sb.st_mtime < log_sb.st_mtime)
-	*clean_flag = 0;
-    else
-	*clean_flag = 1;
-    safeunlink(clean_path, 1);
-    safe_free(swaplog_path);
-    safe_free(clean_path);
-    safe_free(new_path);
-    return fp;
-}
-
-void
-storeDirCloseTmpSwapLog(int dirn)
-{
-    char *swaplog_path = xstrdup(storeDirSwapLogFile(dirn, NULL));
-    char *new_path = xstrdup(storeDirSwapLogFile(dirn, ".new"));
-    SwapDir *SD = &Config.cacheSwap.swapDirs[dirn];
-    int fd;
-    file_close(SD->swaplog_fd);
-#ifdef _SQUID_OS2_
-    if (unlink(swaplog_path) < 0) {
-	debug(50, 0) ("%s: %s\n", swaplog_path, xstrerror());
-	fatal("storeDirCloseTmpSwapLog: unlink failed");
-    }
-#endif
-    if (rename(new_path, swaplog_path) < 0) {
-	debug(50, 0) ("%s,%s: %s\n", new_path, swaplog_path, xstrerror());
-	fatal("storeDirCloseTmpSwapLog: rename failed");
-    }
-    fd = file_open(swaplog_path, O_WRONLY | O_CREAT, NULL, NULL, NULL);
-    if (fd < 0) {
-	debug(50, 1) ("%s: %s\n", swaplog_path, xstrerror());
-	fatal("storeDirCloseTmpSwapLog: Failed to open swap log.");
-    }
-    safe_free(swaplog_path);
-    safe_free(new_path);
-    SD->swaplog_fd = fd;
-    debug(47, 3) ("Cache Dir #%d log opened on FD %d\n", dirn, fd);
+    sd = &Config.cacheSwap.swapDirs[dirn];
+    sd->log.write(sd, e, op);
 }
 
 void
@@ -582,11 +287,6 @@
 void
 storeDirStats(StoreEntry * sentry)
 {
-    int i;
-    SwapDir *SD;
-#if HAVE_STATVFS
-    struct statvfs sfs;
-#endif
     storeAppendPrintf(sentry, "Store Directory Statistics:\n");
     storeAppendPrintf(sentry, "Store Entries          : %d\n",
 	memInUse(MEM_STOREENTRY));
@@ -597,40 +297,7 @@
     storeAppendPrintf(sentry, "Current Capacity       : %d%% used, %d%% free\n",
 	percent((int) store_swap_size, (int) Config.Swap.maxSize),
 	percent((int) (Config.Swap.maxSize - store_swap_size), (int) Config.Swap.maxSize));
-    for (i = 0; i < Config.cacheSwap.n_configured; i++) {
-	SD = &Config.cacheSwap.swapDirs[i];
-	storeAppendPrintf(sentry, "\n");
-	storeAppendPrintf(sentry, "Store Directory #%d: %s\n", i, SD->path);
-	storeAppendPrintf(sentry, "First level subdirectories: %d\n", SD->l1);
-	storeAppendPrintf(sentry, "Second level subdirectories: %d\n", SD->l2);
-	storeAppendPrintf(sentry, "Maximum Size: %d KB\n", SD->max_size);
-	storeAppendPrintf(sentry, "Current Size: %d KB\n", SD->cur_size);
-	storeAppendPrintf(sentry, "Percent Used: %0.2f%%\n",
-	    100.0 * SD->cur_size / SD->max_size);
-	storeAppendPrintf(sentry, "Filemap bits in use: %d of %d (%d%%)\n",
-	    SD->map->n_files_in_map, SD->map->max_n_files,
-	    percent(SD->map->n_files_in_map, SD->map->max_n_files));
-#if HAVE_STATVFS
-#define fsbtoblk(num, fsbs, bs) \
-        (((fsbs) != 0 && (fsbs) < (bs)) ? \
-                (num) / ((bs) / (fsbs)) : (num) * ((fsbs) / (bs)))
-	if (!statvfs(SD->path, &sfs)) {
-	    storeAppendPrintf(sentry, "Filesystem Space in use: %d/%d KB (%d%%)\n",
-		fsbtoblk((sfs.f_blocks - sfs.f_bfree), sfs.f_frsize, 1024),
-		fsbtoblk(sfs.f_blocks, sfs.f_frsize, 1024),
-		percent(sfs.f_blocks - sfs.f_bfree, sfs.f_blocks));
-	    storeAppendPrintf(sentry, "Filesystem Inodes in use: %d/%d (%d%%)\n",
-		sfs.f_files - sfs.f_ffree, sfs.f_files,
-		percent(sfs.f_files - sfs.f_ffree, sfs.f_files));
-	}
-#endif
-	storeAppendPrintf(sentry, "Flags:");
-	if (SD->flags.selected)
-	    storeAppendPrintf(sentry, " SELECTED");
-	if (SD->flags.read_only)
-	    storeAppendPrintf(sentry, " READ-ONLY");
-	storeAppendPrintf(sentry, "\n");
-    }
+    storeUfsDirStats(sentry);	/* XXX */
 }
 
 int
@@ -643,6 +310,53 @@
     return n;
 }
 
+void
+storeDirConfigure(void)
+{
+    SwapDir *SD;
+    int i;
+    Config.Swap.maxSize = 0;
+    for (i = 0; i < Config.cacheSwap.n_configured; i++) {
+	SD = &Config.cacheSwap.swapDirs[i];;
+	Config.Swap.maxSize += SD->max_size;
+	if (NULL == SD->map)
+	    SD->map = file_map_create();
+    }
+}
+
+void
+storeDirDiskFull(int fn)
+{
+    int dirn = fn >> SWAP_DIR_SHIFT;
+    SwapDir *SD = &Config.cacheSwap.swapDirs[dirn];
+    assert(0 <= dirn && dirn < Config.cacheSwap.n_configured);
+    SD->max_size = SD->cur_size;
+    debug(20, 1) ("WARNING: Shrinking cache_dir #%d to %d KB\n",
+	dirn, SD->cur_size);
+}
+
+void
+storeDirOpenSwapLogs(void)
+{
+    int dirn;
+    SwapDir *sd;
+    for (dirn = 0; dirn < Config.cacheSwap.n_configured; dirn++) {
+	sd = &Config.cacheSwap.swapDirs[dirn];
+	sd->log.open(sd);
+    }
+}
+
+void
+storeDirCloseSwapLogs(void)
+{
+    int dirn;
+    SwapDir *sd;
+    for (dirn = 0; dirn < Config.cacheSwap.n_configured; dirn++) {
+	sd = &Config.cacheSwap.swapDirs[dirn];
+	sd->log.close(sd);
+    }
+}
+
 /*
  *  storeDirWriteCleanLogs
  * 
@@ -653,62 +367,45 @@
 storeDirWriteCleanLogs(int reopen)
 {
     StoreEntry *e = NULL;
-    int *fd;
     int n = 0;
-    time_t start, stop, r;
-    struct stat sb;
-    char **cur;
-    char **new;
-    char **cln;
+    struct timeval start;
+    double dt;
+    SwapDir *sd;
     int dirn;
     int N = Config.cacheSwap.n_configured;
+#if HEAP_REPLACEMENT
+    int node;
+#else
     dlink_node *m;
-    char **outbuf;
-    off_t *outbufoffset;
-    storeSwapLogData s;
-    size_t ss = sizeof(storeSwapLogData);
-    if (store_rebuilding) {
+#endif
+    if (store_dirs_rebuilding) {
 	debug(20, 1) ("Not currently OK to rewrite swap log.\n");
 	debug(20, 1) ("storeDirWriteCleanLogs: Operation aborted.\n");
 	return 0;
     }
     debug(20, 1) ("storeDirWriteCleanLogs: Starting...\n");
-    start = squid_curtime;
-    fd = xcalloc(N, sizeof(int));
-    cur = xcalloc(N, sizeof(char *));
-    new = xcalloc(N, sizeof(char *));
-    cln = xcalloc(N, sizeof(char *));
-    for (dirn = 0; dirn < N; dirn++) {
-	fd[dirn] = -1;
-	cur[dirn] = xstrdup(storeDirSwapLogFile(dirn, NULL));
-	new[dirn] = xstrdup(storeDirSwapLogFile(dirn, ".clean"));
-	cln[dirn] = xstrdup(storeDirSwapLogFile(dirn, ".last-clean"));
-	unlink(new[dirn]);
-	unlink(cln[dirn]);
-	fd[dirn] = file_open(new[dirn],
-	    O_WRONLY | O_CREAT | O_TRUNC,
-	    NULL,
-	    NULL,
-	    NULL);
-	if (fd[dirn] < 0) {
-	    debug(50, 0) ("storeDirWriteCleanLogs: %s: %s\n", new[dirn], xstrerror());
+    getCurrentTime();
+    start = current_time;
+    for (dirn = 0; dirn < Config.cacheSwap.n_configured; dirn++) {
+	sd = &Config.cacheSwap.swapDirs[dirn];
+	if (sd->log.clean.open(sd) < 0) {
+	    debug(20, 1) ("log.clean.open() failed for dir #%d\n", sd->index);
 	    continue;
 	}
-	debug(20, 3) ("storeDirWriteCleanLogs: opened %s, FD %d\n",
-	    new[dirn], fd[dirn]);
-#if HAVE_FCHMOD
-	if (stat(cur[dirn], &sb) == 0)
-	    fchmod(fd[dirn], sb.st_mode);
-#endif
-    }
-    outbuf = xcalloc(N, sizeof(char *));
-    outbufoffset = xcalloc(N, sizeof(*outbufoffset));
-    for (dirn = 0; dirn < N; dirn++) {
-	outbuf[dirn] = xcalloc(CLEAN_BUF_SZ, 1);
-	outbufoffset[dirn] = 0;
     }
-    for (m = store_list.tail; m; m = m->prev) {
+#if HEAP_REPLACEMENT
+    if (NULL == store_heap)
+	return 0;
+    for (node = 0; node < heap_nodes(store_heap); node++)
+#else
+    for (m = store_list.tail; m; m = m->prev)
+#endif
+    {
+#if HEAP_REPLACEMENT
+	e = (StoreEntry *) heap_peep(store_heap, node);
+#else
 	e = m->data;
+#endif
 	if (e->swap_file_number < 0)
 	    continue;
 	if (e->swap_status != SWAPOUT_DONE)
@@ -722,35 +419,10 @@
 	if (EBIT_TEST(e->flags, ENTRY_SPECIAL))
 	    continue;
 	dirn = storeDirNumber(e->swap_file_number);
-	assert(dirn < N);
-	if (fd[dirn] < 0)
+	sd = &Config.cacheSwap.swapDirs[dirn];
+	if (NULL == sd->log.clean.write)
 	    continue;
-	memset(&s, '\0', ss);
-	s.op = (char) SWAP_LOG_ADD;
-	s.swap_file_number = e->swap_file_number;
-	s.timestamp = e->timestamp;
-	s.lastref = e->lastref;
-	s.expires = e->expires;
-	s.lastmod = e->lastmod;
-	s.swap_file_sz = e->swap_file_sz;
-	s.refcount = e->refcount;
-	s.flags = e->flags;
-	xmemcpy(&s.key, e->key, MD5_DIGEST_CHARS);
-	xmemcpy(outbuf[dirn] + outbufoffset[dirn], &s, ss);
-	outbufoffset[dirn] += ss;
-	/* buffered write */
-	if (outbufoffset[dirn] + ss > CLEAN_BUF_SZ) {
-	    if (write(fd[dirn], outbuf[dirn], outbufoffset[dirn]) < 0) {
-		debug(50, 0) ("storeDirWriteCleanLogs: %s: write: %s\n",
-		    new[dirn], xstrerror());
-		debug(20, 0) ("storeDirWriteCleanLogs: Current swap logfile not replaced.\n");
-		file_close(fd[dirn]);
-		fd[dirn] = -1;
-		unlink(new[dirn]);
-		continue;
-	    }
-	    outbufoffset[dirn] = 0;
-	}
+	sd->log.clean.write(e, sd);
 	if ((++n & 0xFFFF) == 0) {
 	    getCurrentTime();
 	    debug(20, 1) ("  %7d entries written so far.\n", n);
@@ -758,112 +430,18 @@
     }
     /* flush */
     for (dirn = 0; dirn < N; dirn++) {
-	if (outbufoffset[dirn] == 0)
-	    continue;
-	if (fd[dirn] < 0)
-	    continue;
-	if (write(fd[dirn], outbuf[dirn], outbufoffset[dirn]) < 0) {
-	    debug(50, 0) ("storeDirWriteCleanLogs: %s: write: %s\n",
-		new[dirn], xstrerror());
-	    debug(20, 0) ("storeDirWriteCleanLogs: Current swap logfile not replaced.\n");
-	    file_close(fd[dirn]);
-	    fd[dirn] = -1;
-	    unlink(new[dirn]);
-	    continue;
-	}
-	safe_free(outbuf[dirn]);
-    }
-    safe_free(outbuf);
-    safe_free(outbufoffset);
-    /*
-     * You can't rename open files on Microsoft "operating systems"
-     * so we have to close before renaming.
-     */
-    storeDirCloseSwapLogs();
-    /* rename */
-    for (dirn = 0; dirn < N; dirn++) {
-	if (fd[dirn] < 0)
+	sd = &Config.cacheSwap.swapDirs[dirn];
+	if (NULL == sd->log.clean.write)
 	    continue;
-#ifdef _SQUID_OS2_
-	file_close(fd[dirn]);
-	fd[dirn] = -1;
-	if (unlink(cur[dirn]) < 0)
-	    debug(50, 0) ("storeDirWriteCleanLogs: unlinkd failed: %s, %s\n",
-		xstrerror(), cur[dirn]);
-#endif
-	if (rename(new[dirn], cur[dirn]) < 0) {
-	    debug(50, 0) ("storeDirWriteCleanLogs: rename failed: %s, %s -> %s\n",
-		xstrerror(), new[dirn], cur[dirn]);
-	}
+	sd->log.clean.write(NULL, sd);
     }
     if (reopen)
 	storeDirOpenSwapLogs();
-    stop = squid_curtime;
-    r = stop - start;
+    getCurrentTime();
+    dt = tvSubDsec(start, current_time);
     debug(20, 1) ("  Finished.  Wrote %d entries.\n", n);
-    debug(20, 1) ("  Took %d seconds (%6.1f entries/sec).\n",
-	r > 0 ? (int) r : 0,
-	(double) n / (r > 0 ? r : 1));
-    /* touch a timestamp file if we're not still validating */
-    if (!store_rebuilding) {
-	for (dirn = 0; dirn < N; dirn++) {
-	    if (fd[dirn] < 0)
-		continue;
-	    file_close(file_open(cln[dirn],
-		    O_WRONLY | O_CREAT | O_TRUNC, NULL, NULL, NULL));
-	}
-    }
-    /* close */
-    for (dirn = 0; dirn < N; dirn++) {
-	safe_free(cur[dirn]);
-	safe_free(new[dirn]);
-	safe_free(cln[dirn]);
-	if (fd[dirn] < 0)
-	    continue;
-	file_close(fd[dirn]);
-	fd[dirn] = -1;
-    }
-    safe_free(cur);
-    safe_free(new);
-    safe_free(cln);
-    safe_free(fd);
+    debug(20, 1) ("  Took %3.1f seconds (%6.1f entries/sec).\n",
+	dt, (double) n / (dt > 0.0 ? dt : 1.0));
     return n;
 }
 #undef CLEAN_BUF_SZ
-
-void
-storeDirConfigure(void)
-{
-    SwapDir *SD;
-    int n;
-    int i;
-    fileMap *fm;
-    Config.Swap.maxSize = 0;
-    for (i = 0; i < Config.cacheSwap.n_configured; i++) {
-	SD = &Config.cacheSwap.swapDirs[i];;
-	Config.Swap.maxSize += SD->max_size;
-	n = 2 * SD->max_size / Config.Store.avgObjectSize;
-	if (NULL == SD->map) {
-	    /* first time */
-	    SD->map = file_map_create(n);
-	} else if (n > SD->map->max_n_files) {
-	    /* it grew, need to expand */
-	    fm = file_map_create(n);
-	    filemapCopy(SD->map, fm);
-	    filemapFreeMemory(SD->map);
-	    SD->map = fm;
-	}
-	/* else it shrunk, and we leave the old one in place */
-    }
-}
-
-void
-storeDirDiskFull(int fn)
-{
-    int dirn = fn >> SWAP_DIR_SHIFT;
-    SwapDir *SD = &Config.cacheSwap.swapDirs[dirn];
-    assert(0 <= dirn && dirn < Config.cacheSwap.n_configured);
-    SD->max_size = SD->cur_size;
-    debug(20, 1) ("WARNING: Shrinking cache_dir #%d to %d KB\n",
-	dirn, SD->cur_size);
-}
Index: squid/src/store_dir_ufs.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/Attic/store_dir_ufs.c,v
retrieving revision 1.1
retrieving revision 1.1.1.1
diff -u -r1.1 -r1.1.1.1
--- squid/src/store_dir_ufs.c	26 Jan 2000 03:25:01 -0000	1.1
+++ squid/src/store_dir_ufs.c	26 Jan 2000 03:25:01 -0000	1.1.1.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: store_dir_ufs.c,v 1.1 2000/01/26 03:25:01 hno Exp $
+ * $Id: store_dir_ufs.c,v 1.1.1.1 2000/01/26 03:25:01 hno Exp $
  *
  * DEBUG: section 47    Store Directory Routines
  * AUTHOR: Duane Wessels
Index: squid/src/store_heap_replacement.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/Attic/store_heap_replacement.c,v
retrieving revision 1.1
retrieving revision 1.1.1.1
diff -u -r1.1 -r1.1.1.1
--- squid/src/store_heap_replacement.c	26 Jan 2000 03:25:01 -0000	1.1
+++ squid/src/store_heap_replacement.c	26 Jan 2000 03:25:01 -0000	1.1.1.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: store_heap_replacement.c,v 1.1 2000/01/26 03:25:01 hno Exp $
+ * $Id: store_heap_replacement.c,v 1.1.1.1 2000/01/26 03:25:01 hno Exp $
  *
  * DEBUG: section 20    Storage Manager Heap-based replacement
  * AUTHOR: John Dilley
Index: squid/src/store_io_ufs.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/Attic/store_io_ufs.c,v
retrieving revision 1.1
retrieving revision 1.1.1.1
diff -u -r1.1 -r1.1.1.1
--- squid/src/store_io_ufs.c	26 Jan 2000 03:25:01 -0000	1.1
+++ squid/src/store_io_ufs.c	26 Jan 2000 03:25:01 -0000	1.1.1.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: store_io_ufs.c,v 1.1 2000/01/26 03:25:01 hno Exp $
+ * $Id: store_io_ufs.c,v 1.1.1.1 2000/01/26 03:25:01 hno Exp $
  *
  * DEBUG: section 79    Storage Manager UFS Interface
  * AUTHOR: Duane Wessels
Index: squid/src/store_key_md5.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/store_key_md5.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.3
diff -u -r1.1.1.2 -r1.1.1.3
--- squid/src/store_key_md5.c	26 Jan 2000 03:23:10 -0000	1.1.1.2
+++ squid/src/store_key_md5.c	26 Jan 2000 03:25:01 -0000	1.1.1.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: store_key_md5.c,v 1.1.1.2 2000/01/26 03:23:10 hno Exp $
+ * $Id: store_key_md5.c,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
  *
  * DEBUG: section 20    Storage Manager MD5 Cache Keys
  * AUTHOR: Duane Wessels
@@ -142,15 +142,12 @@
 }
 
 int
-storeKeyHashBuckets(int nobj)
+storeKeyHashBuckets(int nbuckets)
 {
-    if (nobj < 0x2000)
-	return 0x2000;
-    if (nobj < 0x4000)
-	return 0x4000;
-    if (nobj < 0x8000)
-	return 0x8000;
-    return 0x10000;
+    int n = 0x2000;
+    while (n < nbuckets)
+	n <<= 1;
+    return n;
 }
 
 int
Index: squid/src/store_log.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/store_log.c,v
retrieving revision 1.1.1.1
retrieving revision 1.1.1.2
diff -u -r1.1.1.1 -r1.1.1.2
--- squid/src/store_log.c	26 Jan 2000 03:21:47 -0000	1.1.1.1
+++ squid/src/store_log.c	26 Jan 2000 03:25:01 -0000	1.1.1.2
@@ -1,6 +1,6 @@
 
 /*
- * $Id: store_log.c,v 1.1.1.1 2000/01/26 03:21:47 hno Exp $
+ * $Id: store_log.c,v 1.1.1.2 2000/01/26 03:25:01 hno Exp $
  *
  * DEBUG: section 20    Storage Manager Logging Functions
  * AUTHOR: Duane Wessels
@@ -55,6 +55,8 @@
 	return;
     if (mem == NULL)
 	return;
+    if (EBIT_TEST(e->flags, ENTRY_DONT_LOG))
+	return;
     if (mem->log_url == NULL) {
 	debug(20, 1) ("storeLog: NULL log_url for %s\n", mem->url);
 	storeMemObjectDump(mem);
@@ -71,7 +73,7 @@
 	(int) reply->date,
 	(int) reply->last_modified,
 	(int) reply->expires,
-	strBuf(reply->content_type) ? strBuf(reply->content_type) : "unknown",
+	strLen(reply->content_type) ? strBuf(reply->content_type) : "unknown",
 	reply->content_length,
 	(int) (mem->inmem_hi - mem->reply->hdr_sz),
 	RequestMethodStr[mem->method],
@@ -111,14 +113,14 @@
 	i--;
 	snprintf(from, MAXPATHLEN, "%s.%d", fname, i - 1);
 	snprintf(to, MAXPATHLEN, "%s.%d", fname, i);
-	rename(from, to);
+	xrename(from, to);
     }
     /* Rotate the current log to .0 */
     if (Config.Log.rotateNumber > 0) {
 	snprintf(to, MAXPATHLEN, "%s.%d", fname, 0);
-	rename(fname, to);
+	xrename(fname, to);
     }
-    storelog_fd = file_open(fname, O_WRONLY | O_CREAT, NULL, NULL, NULL);
+    storelog_fd = file_open(fname, O_WRONLY | O_CREAT);
     if (storelog_fd < 0) {
 	debug(50, 0) ("storeLogRotate: %s: %s\n", fname, xstrerror());
 	debug(20, 1) ("Store logging disabled\n");
@@ -138,11 +140,7 @@
     if (strcmp(Config.Log.store, "none") == 0)
 	storelog_fd = -1;
     else
-	storelog_fd = file_open(Config.Log.store,
-	    O_WRONLY | O_CREAT,
-	    NULL,
-	    NULL,
-	    NULL);
+	storelog_fd = file_open(Config.Log.store, O_WRONLY | O_CREAT);
     if (storelog_fd < 0)
 	debug(20, 1) ("Store logging disabled\n");
 }
